//
//  ViewController.m
//  ParallaxSample
//
//  Created by Tom Nys on 07/04/12.
//  Copyright (c) 2012 Netwalk VOF. All rights reserved.
//

#import "ViewController.h"
#import <QuartzCore/QuartzCore.h>

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	majorTextScrollFactor = 1.2;
	minorTextScrollFactor = 1.4;
	self.view.backgroundColor = [UIColor blackColor];
	
	imageScrollView = [[UIScrollView alloc] initWithFrame:self.view.bounds];
	UITapGestureRecognizer* recognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(parallaxTapped:)];
	[imageScrollView addGestureRecognizer:recognizer];
	CGFloat xPos = 134;
	CGFloat imageWidth = 500.;
	CGFloat imageSpacing = 100.;
	for (int i = 0; i < 6; i++)
	{
		UIImageView* iv = [[UIImageView alloc] initWithFrame:CGRectMake(xPos, 250, imageWidth, 350)];
		iv.image = [UIImage imageNamed:@"sample_parallax"];
		iv.tag = i;
		[imageScrollView addSubview:iv];
		xPos += (imageWidth + imageSpacing);
	}
	imageScrollView.contentSize = CGSizeMake(xPos, self.view.bounds.size.height);
	imageScrollView.delegate = self;
	[self.view addSubview:imageScrollView];
	
	majorTextScrollView = [[UIScrollView alloc] initWithFrame:self.view.bounds];
	majorTextScrollView.userInteractionEnabled = NO;
	xPos = 160;
	for (int i = 0; i < 6; i++)
	{
		UILabel* lbl = [[UILabel alloc] initWithFrame:CGRectMake(xPos, 500, imageWidth * majorTextScrollFactor, 200)];
		lbl.backgroundColor = [UIColor clearColor];
		lbl.textColor = [UIColor whiteColor];
		lbl.layer.shadowColor = [UIColor blackColor].CGColor;
		lbl.layer.shadowOpacity = .5;
		lbl.layer.shadowRadius = 10.;
		lbl.text = @"Sample Title";
		lbl.font = [UIFont systemFontOfSize:60.0];
		[majorTextScrollView addSubview:lbl];
		xPos += (imageWidth + imageSpacing) * majorTextScrollFactor;
	}
	
	majorTextScrollView.contentSize = CGSizeMake(xPos - imageSpacing * majorTextScrollFactor, self.view.bounds.size.height);
	[self.view addSubview:majorTextScrollView];
	
	minorTextScrollView = [[UIScrollView alloc] initWithFrame:self.view.bounds];
	minorTextScrollView.userInteractionEnabled = NO;
	xPos = 160;
	for (int i = 0; i < 6; i++)
	{
		UILabel* lbl = [[UILabel alloc] initWithFrame:CGRectMake(xPos, 650, imageWidth * minorTextScrollFactor, 50)];
		lbl.backgroundColor = [UIColor clearColor];
		lbl.textColor = [UIColor whiteColor];
		lbl.numberOfLines = 2;
		lbl.text = @"Stay up to date\nwith the latest trends";
		lbl.font = [UIFont boldSystemFontOfSize:20.0];
		[minorTextScrollView addSubview:lbl];
		xPos += (imageWidth + imageSpacing) * minorTextScrollFactor;
	}
	
	minorTextScrollView.contentSize = CGSizeMake(xPos - imageSpacing * minorTextScrollFactor, self.view.bounds.size.height);
	[self.view addSubview:minorTextScrollView];
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
	minorTextScrollView.contentOffset = CGPointMake(scrollView.contentOffset.x * minorTextScrollFactor, 0);
	majorTextScrollView.contentOffset = CGPointMake(scrollView.contentOffset.x * majorTextScrollFactor, 0);
}

-(void)parallaxTapped:(UITapGestureRecognizer*)recognizer
{
	CGPoint touch = [recognizer locationInView:imageScrollView];
	for (UIView* v in imageScrollView.subviews)
	{
		if (CGRectContainsPoint(v.frame, touch))
		{
			NSLog(@"You touched parallax %d", v.tag + 1);
		}
	}
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
	return YES;
}

@end
